blob: ce273fe0e48d997cb067e77707026616a9302eb2 [file] [log] [blame]
Jonathan Nieder11d62142013-11-25 13:03:52 -08001# This shell scriplet is meant to be included by other shell scripts
2# to set up some variables pointing at the normal git directories and
3# a few helper shell functions.
Linus Torvaldsb33e9662005-07-08 10:57:21 -07004
Junio C Hamano365527a2005-09-12 19:47:07 -07005# Having this variable in your environment would break scripts because
Junio C Hamanoe598c512007-09-15 16:32:23 -07006# you would cause "cd" to be taken to unexpected places. If you
Junio C Hamano365527a2005-09-12 19:47:07 -07007# like CDPATH, define it for your interactive shell sessions without
8# exporting it.
Junio C Hamano785063e2012-08-08 12:08:17 -07009# But we protect ourselves from such a user mistake nevertheless.
Junio C Hamano365527a2005-09-12 19:47:07 -070010unset CDPATH
11
Junio C Hamano393050c2012-12-07 14:31:52 -080012# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13# do not equate an unset IFS with IFS with the default, so here is
14# an explicit SP HT LF.
15IFS='
16'
Junio C Hamano785063e2012-08-08 12:08:17 -070017
Junio C Hamano61dbb3c2009-06-08 09:41:49 -070018git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
21 *)
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
28 do
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
39 )
40 ;;
41 esac
42}
43
44# @@BROKEN_PATH_FIX@@
Junio C Hamano0e0aea52009-06-05 18:36:15 -050045
Anders Kaseorg10730942016-10-29 22:10:02 -040046# Source git-sh-i18n for gettext support.
47. "$(git --exec-path)/git-sh-i18n"
48
Fredrik Gustafssonadb231c2011-06-09 09:47:02 +020049die () {
50 die_with_status 1 "$@"
51}
52
53die_with_status () {
54 status=$1
55 shift
Matthieu Moy89b02302013-08-07 11:26:05 +020056 printf >&2 '%s\n' "$*"
Fredrik Gustafssonadb231c2011-06-09 09:47:02 +020057 exit "$status"
Linus Torvaldsb33e9662005-07-08 10:57:21 -070058}
59
Pierre Habouzitbac199b2007-11-04 11:30:54 +010060if test -n "$OPTIONS_SPEC"; then
61 usage() {
Junio C Hamano5d292752007-12-20 12:58:06 -080062 "$0" -h
63 exit 1
Pierre Habouzitbac199b2007-11-04 11:30:54 +010064 }
65
Pierre Habouzite817e3e2007-11-08 10:32:11 +010066 parseopt_extra=
67 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
68 parseopt_extra="--keep-dashdash"
Nicolas Vigier51ba8ce2014-02-01 02:17:59 +000069 [ -n "$OPTIONS_STUCKLONG" ] &&
70 parseopt_extra="$parseopt_extra --stuck-long"
Pierre Habouzite817e3e2007-11-08 10:32:11 +010071
72 eval "$(
Junio C Hamanocbea86f2007-11-07 23:04:38 -080073 echo "$OPTIONS_SPEC" |
Pierre Habouzite817e3e2007-11-08 10:32:11 +010074 git rev-parse --parseopt $parseopt_extra -- "$@" ||
75 echo exit $?
76 )"
Pierre Habouzitbac199b2007-11-04 11:30:54 +010077else
Dan Wyand7d665f32014-11-24 18:03:31 -050078 dashless=$(basename -- "$0" | sed -e 's/-/ /')
Pierre Habouzitbac199b2007-11-04 11:30:54 +010079 usage() {
Vasco Almeidad323c6b2016-06-17 20:21:02 +000080 die "$(eval_gettext "usage: \$dashless \$USAGE")"
Pierre Habouzitbac199b2007-11-04 11:30:54 +010081 }
82
83 if [ -z "$LONG_USAGE" ]
84 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +000085 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")"
Pierre Habouzitbac199b2007-11-04 11:30:54 +010086 else
Vasco Almeidad323c6b2016-06-17 20:21:02 +000087 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE
Pierre Habouzitbac199b2007-11-04 11:30:54 +010088
Vasco Almeidad323c6b2016-06-17 20:21:02 +000089$LONG_USAGE")"
Pierre Habouzitbac199b2007-11-04 11:30:54 +010090 fi
91
92 case "$1" in
Clemens Buchacher87182b12011-10-03 20:21:36 +020093 -h)
Pierre Habouzitbac199b2007-11-04 11:30:54 +010094 echo "$LONG_USAGE"
95 exit
96 esac
97fi
Fredrik Kuivinend0255242005-12-11 10:55:49 +010098
Junio C Hamanoc3e2d182013-06-19 10:54:00 -070099# Set the name of the end-user facing command in the reflog when the
100# script may update refs. When GIT_REFLOG_ACTION is already set, this
101# will not overwrite it, so that a scripted Porcelain (e.g. "git
102# rebase") can set it to its own name (e.g. "rebase") and then call
103# another scripted Porcelain (e.g. "git am") and a call to this
104# function in the latter will keep the name of the end-user facing
105# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
106# does will be record as actions done as part of the end-user facing
107# operation (e.g. "rebase").
108#
109# NOTE NOTE NOTE: consequently, after assigning a specific message to
110# GIT_REFLOG_ACTION when calling a "git" command to record a custom
111# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
112# after you are done. Other callers of "git" commands that rely on
113# writing the default "program name" in reflog expect the variable to
114# contain the value set by this function.
115#
116# To use a custom reflog message, do either one of these three:
117#
118# (a) use a single-shot export form:
119# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
120# git command-that-updates-a-ref
121#
122# (b) save the original away and restore:
123# SAVED_ACTION=$GIT_REFLOG_ACTION
124# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
125# git command-that-updates-a-ref
126# GIT_REFLOG_ACITON=$SAVED_ACTION
127#
128# (c) assign the variable in a subshell:
129# (
130# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
131# git command-that-updates-a-ref
132# )
Shawn O. Pearcef9474132006-12-28 02:34:48 -0500133set_reflog_action() {
134 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
135 then
136 GIT_REFLOG_ACTION="$*"
137 export GIT_REFLOG_ACTION
138 fi
139}
140
Adam Robenef0c2ab2007-07-19 22:09:35 -0700141git_editor() {
Jonathan Niederb4479f02009-10-30 20:42:34 -0500142 if test -z "${GIT_EDITOR:+set}"
143 then
144 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
145 fi
146
147 eval "$GIT_EDITOR" '"$@"'
Adam Robenef0c2ab2007-07-19 22:09:35 -0700148}
149
Jonathan Niederf6dff112010-02-14 23:04:13 -0600150git_pager() {
151 if test -t 1
152 then
153 GIT_PAGER=$(git var GIT_PAGER)
154 else
155 GIT_PAGER=cat
156 fi
Eric Wong995bc222016-08-04 11:40:25 +0000157 for vardef in @@PAGER_ENV@@
158 do
159 var=${vardef%%=*}
160 eval ": \"\${$vardef}\" && export $var"
161 done
Jonathan Niederf6dff112010-02-14 23:04:13 -0600162
163 eval "$GIT_PAGER" '"$@"'
164}
165
Junio C Hamano4b441f42007-01-07 02:17:52 -0800166is_bare_repository () {
Junio C Hamano5be60072007-07-02 22:52:14 -0700167 git rev-parse --is-bare-repository
Junio C Hamano4b441f42007-01-07 02:17:52 -0800168}
169
Junio C Hamano9fde9402007-01-12 12:44:08 -0800170cd_to_toplevel () {
Steven Drake91dc6022010-01-12 11:34:34 +1300171 cdup=$(git rev-parse --show-toplevel) &&
172 cd "$cdup" || {
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000173 gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2
Steven Drake91dc6022010-01-12 11:34:34 +1300174 exit 1
175 }
Junio C Hamano9fde9402007-01-12 12:44:08 -0800176}
177
Junio C Hamanoe2eb5272011-05-04 19:11:18 -0700178require_work_tree_exists () {
179 if test "z$(git rev-parse --is-bare-repository)" != zfalse
180 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000181 program_name=$0
Junio C Hamanoacefe2b2016-12-20 09:36:23 -0800182 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
Junio C Hamanoe2eb5272011-05-04 19:11:18 -0700183 fi
184}
185
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -0500186require_work_tree () {
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000187 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || {
188 program_name=$0
Junio C Hamanoacefe2b2016-12-20 09:36:23 -0800189 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000190 }
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -0500191}
192
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530193require_clean_work_tree () {
194 git rev-parse --verify HEAD >/dev/null || exit 1
195 git update-index -q --ignore-submodules --refresh
196 err=0
197
198 if ! git diff-files --quiet --ignore-submodules
199 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000200 action=$1
201 case "$action" in
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000202 "rewrite branches")
203 gettextln "Cannot rewrite branches: You have unstaged changes." >&2
204 ;;
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000205 *)
206 eval_gettextln "Cannot \$action: You have unstaged changes." >&2
207 ;;
208 esac
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530209 err=1
210 fi
211
212 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
213 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000214 if test $err = 0
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530215 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000216 action=$1
Ævar Arnfjörð Bjarmasonc1e10b22021-10-21 20:37:33 +0200217 eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530218 else
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000219 gettextln "Additionally, your index contains uncommitted changes." >&2
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530220 fi
221 err=1
222 fi
223
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000224 if test $err = 1
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530225 then
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000226 test -n "$2" && echo "$2" >&2
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530227 exit 1
228 fi
229}
230
Jeff Kingce80ca52012-10-18 03:25:22 -0400231# Generate a sed script to parse identities from a commit.
232#
233# Reads the commit from stdin, which should be in raw format (e.g., from
234# cat-file or "--pretty=raw").
235#
236# The first argument specifies the ident line to parse (e.g., "author"), and
237# the second specifies the environment variable to put it in (e.g., "AUTHOR"
238# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
239# committer.
240pick_ident_script () {
241 while test $# -gt 0
242 do
243 lid=$1; shift
244 uid=$1; shift
245 printf '%s' "
246 /^$lid /{
247 s/'/'\\\\''/g
248 h
249 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
250 s/.*/GIT_${uid}_NAME='&'/p
251
252 g
253 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
254 s/.*/GIT_${uid}_EMAIL='&'/p
255
256 g
257 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
258 s/.*/GIT_${uid}_DATE='&'/p
259 }
260 "
261 done
262 echo '/^$/q'
263}
264
265# Create a pick-script as above and feed it to sed. Stdout is suitable for
266# feeding to eval.
267parse_ident_from_commit () {
268 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
269}
270
271# Parse the author from a commit given as an argument. Stdout is suitable for
272# feeding to eval to set the usual GIT_* ident variables.
Johannes Schindelin0cae2342007-06-25 01:04:11 +0100273get_author_ident_from_commit () {
Johannes Schindelin0cae2342007-06-25 01:04:11 +0100274 encoding=$(git config i18n.commitencoding || echo UTF-8)
Junio C Hamano077b7252008-02-13 13:13:21 -0800275 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
Jeff Kingce80ca52012-10-18 03:25:22 -0400276 parse_ident_from_commit author AUTHOR
Johannes Schindelin0cae2342007-06-25 01:04:11 +0100277}
278
Kevin Bracey45491622013-03-13 03:12:21 +0200279# Generate a virtual base file for a two-file merge. Uses git apply to
280# remove lines from $1 that are not in $2, leaving only common lines.
281create_virtual_base() {
282 sz0=$(wc -c <"$1")
283 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
284 sz1=$(wc -c <"$1")
285
286 # If we do not have enough common material, it is not
287 # worth trying two-file merge using common subsections.
288 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
289}
290
Johannes Sixt87bddba2007-11-30 22:06:30 +0100291
Junio C Hamano10587ce2012-05-16 10:36:01 -0700292# Platform specific tweaks to work around some commands
Johannes Sixt87bddba2007-11-30 22:06:30 +0100293case $(uname -s) in
294*MINGW*)
295 # Windows has its own (incompatible) sort and find
296 sort () {
297 /usr/bin/sort "$@"
298 }
299 find () {
300 /usr/bin/find "$@"
301 }
Ramsay Jonesbe390482012-04-17 19:48:39 +0100302 # git sees Windows-style pwd
303 pwd () {
304 builtin pwd -W
305 }
Pat Thoyts5e9677c2010-09-30 14:24:07 +0100306 is_absolute_path () {
307 case "$1" in
308 [/\\]* | [A-Za-z]:*)
309 return 0 ;;
310 esac
311 return 1
312 }
Johannes Sixt87bddba2007-11-30 22:06:30 +0100313 ;;
Pat Thoyts5e9677c2010-09-30 14:24:07 +0100314*)
315 is_absolute_path () {
316 case "$1" in
317 /*)
318 return 0 ;;
319 esac
320 return 1
321 }
Johannes Sixt87bddba2007-11-30 22:06:30 +0100322esac
Junio C Hamano10587ce2012-05-16 10:36:01 -0700323
324# Make sure we are in a valid repository of a vintage we understand,
325# if we require to be in a git repository.
David Aguilar1c7e2d22014-10-11 01:39:36 -0700326git_dir_init () {
Junio C Hamano10587ce2012-05-16 10:36:01 -0700327 GIT_DIR=$(git rev-parse --git-dir) || exit
328 if [ -z "$SUBDIRECTORY_OK" ]
329 then
330 test -z "$(git rev-parse --show-cdup)" || {
331 exit=$?
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000332 gettextln "You need to run this command from the toplevel of the working tree." >&2
Junio C Hamano10587ce2012-05-16 10:36:01 -0700333 exit $exit
334 }
335 fi
336 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
Vasco Almeidad323c6b2016-06-17 20:21:02 +0000337 gettextln "Unable to determine absolute path of git directory" >&2
Junio C Hamano10587ce2012-05-16 10:36:01 -0700338 exit 1
339 }
LE Manh Cuong01247e02016-06-19 03:26:03 +0700340 : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}"
David Aguilar1c7e2d22014-10-11 01:39:36 -0700341}
342
343if test -z "$NONGIT_OK"
344then
345 git_dir_init
Junio C Hamano10587ce2012-05-16 10:36:01 -0700346fi
Ramkumar Ramachandrabac1ddd2013-06-14 18:47:51 +0530347
348peel_committish () {
349 case "$1" in
350 :/*)
351 peeltmp=$(git rev-parse --verify "$1") &&
352 git rev-parse --verify "${peeltmp}^0"
353 ;;
354 *)
355 git rev-parse --verify "${1}^0"
356 ;;
357 esac
358}